Q_all = 80:140; % Range of Q
EP_all = zeros(1, length(Q_all)); % Stores E(P) value for each Q in Q_all
n = 100000;
D = rand(1, n) * (140-80) + 80; % Generate n random demands in [80, 140]
P_all = zeros(1, n);

for i = 1:length(Q_all)
    q = Q_all(i);
    for j = 1:n
        % Monte Carlo simulation, evaluate P
        if D(j) > q
            P_all(j) = 0.6 * q;
        else
            P_all(j) = 0.6 * D(j) - 0.4 * (q - D(j));
        end
    end
    % Estimate E(P) using law of large numbers
    EP_all(i) = sum(P_all)/n;
    % verbatim
    if mod(i, 10)==0
        fprintf('Done %d\n', i);
    end
end

plot(Q_all, EP_all, 'b-');hold on;
[max_EP, max_ind] = max(EP_all);
plot(Q_all(max_ind), max_EP, 'r*', 'MarkerSize' ,10);
fprintf('optimal Q = %d\n', Q_all(max_ind));