%% 1-D
n=100000;
x=2*rand(n,1)+1;
y=x.^2 + x;
estimate = 2* mean(y);


%% 2-D
x=rand(1,n);
y=rand(1,n);
g=4*(x.^2).*y + y.^2;
theta_hat = mean(g);



%% sample size variation
n_all = [10, 20, 30, 50, 100, 200, 300, 500, 1000, 10^4, 10^5, 10^6, 10^8];
estimate_all = zeros(1, length(n_all));
for i = 1:length(n_all)
    n = n_all(i);
    x=rand(1,n);
    y=rand(1,n);
    g=4*(x.^2).*y + y.^2;
    theta_hat = mean(g);
    estimate_all(i) = theta_hat;
end
semilogx(n_all, estimate_all, 'LineWidth', 2);hold on;
% semilogx(n_all, estimate_all, 'r*');
xlabel('n');
ylabel('estimate');

